#include <avr/io.h>
#include <avr/signal.h>
#include <avr/interrupt.h>

#include "a2d.h"

void a2dInit(void)
{
	sbi(ADCSR, ADEN);				// enable ADC 
	cbi(ADCSR, ADFR);				// single sample convert mode
	a2dSetPrescaler(ADC_PRESCALE_DIV32);
	a2dSetReference(ADC_REFERENCE_AVCC);
	cbi(ADMUX, ADLAR);				// zarovnat vpravo
	//sbi(ADCSR, ADIE);				// ADC prerus. zap.
}

void a2dOff(void)
{
	cbi(ADCSR, ADIE);				// vypni prerus
	cbi(ADCSR, ADEN);				// vypni adc
}

void a2dSetPrescaler(unsigned char prescale)
{
	outp( ((inp(ADCSR) & ~ADC_PRESCALE_MASK) | prescale), ADCSR);
}

void a2dSetReference(unsigned char ref)
{
	outp( ((inp(ADMUX) & ~ADC_REFERENCE_MASK) | (ref<<6)), ADMUX);
}

void a2dSetChannel(unsigned char ch)
{
	outp((inp(ADMUX) & ~ADC_MUX_MASK) | (ch & ADC_MUX_MASK), ADMUX);	// nastav kanal
}

void a2dStartConvert(void)
{
	sbi(ADCSR, ADIF);	// smaz flag dokonceni konverze
	sbi(ADCSR, ADSC);	// spust prevodnik
}

unsigned short a2dConvert10bit(void)
{
	return (inp(ADCL) | (inp(ADCH)<<8));	// cti ADC;
}


