/*
 definuje obsluzne procedury systemu
*/


#define SYSCLK 16

#define LEDPORT		PORTD
#define	LEDPINVAL	128		
#define	SPKLEDPINVAL	64

#define LedOn()		LEDPORT|=LEDPINVAL;
#define LedOff()	LEDPORT&=~LEDPINVAL;
#define SpkLedOn()		LEDPORT|=SPKLEDPINVAL;
#define SpkLedOff()	LEDPORT&=~SPKLEDPINVAL;


void DelayUs (unsigned char c)
{
 int i;
 i=SYSCLK*c;
 i=(i >> 2);
 while (i) {
  i--;
 }
}

void DelayMs (unsigned int c)
{
 while (c) {
  c--;
  DelayUs(250);
  DelayUs(250);
  DelayUs(250);
  DelayUs(250);
 }
 
}

void uart_init(unsigned int baud)
{
 UBRRH=(unsigned char)(baud>>8);
 UBRRL=(unsigned char)(baud);
 UCSRA=(1<<UDRE);
 UCSRB=(1<<RXEN)|(1<<TXEN)|(1<<RXCIE);
 UCSRC=128+6;
}

int uart_transmit(char c)
{
 if (c == '\n')
   uart_transmit('\r'); 
 while ( !( UCSRA & (1<<UDRE)) )
  ;
 UDR = c;
 return 0;
}

unsigned char ReceiveByte( void )
{
	while ( !(UCSRA & (1<<RXC)) ); 	/* Wait for incomming data */			                /* Return the data */
	return UDR;
}



void setup(void)
{
	DDRA=0xFC;
    PORTA=0x80;
    PORTB=0xFF;
    DDRC=0xC0;
    PORTC=0x3F;
    DDRD=0xF0;
    PORTD=0x8F;
    DDRB = 0xBD;                            // SPI Port initialisation
                                            // SCK, MISO, MOSI,  CS, LED,  WP , RDYBSY, RST
                                            // PB7, PB6,  PB5,  PB4, PB3, PB2 ,  PB1,   PB0
                                            //  O    I     O     O    O    O      I      O
                                            //  1    0     1     1    1    1      0      1
                                            
    PORTB = 0xFF;                           // all outputs high, inputs have pullups (LED is off) 

//    _SEI();                                 // enable interrupts
}

//zapinani a vypinani audiovystupu
#define PwrOff()		PORTC|=128;
#define PwrOn()	PORTC&=(unsigned char)~128;
