/*

 Modul komunikace s DATAFLASH AD45DB081B a obsluhy nahravani a prehravani zvuku
 Obsluhuje PWM vystup a vystup do TDA1543

*/

#define ADPCM		1
#define	WAVE		0
#define WAVE16		2
#define ADPCM8		3

unsigned char format=WAVE;
static unsigned char usebuf2=0;
unsigned char vole=255,vori=255;

#include "dataflash.h"	//ovladaci kody pro Dataflash

void write_SPI(unsigned char data)
{
       SPDR = data;
       while (!(SPSR & 0x80));             // wait for data transfer to be completed
}


void EraseFlash(unsigned short from, unsigned short to)
{
    unsigned int block_counter = from;
    
    ACSR |= CLEARED;                           // set signal flag that new data has to be recorded next

    // interrupt disabled, SPI port enabled, master mode, MSB first,  SPI mode 3, Fcl/4
    SPCR = 0x5C+1;
    uart_transmit('_');
    while ((block_counter < 512)&&(block_counter <= to))
    {
        PORTB &= ~DF_CHIP_SELECT;           // enable DataFlash
        
        write_SPI(BLOCK_ERASE);
        write_SPI((char)(block_counter>>4));
        write_SPI((char)(block_counter<<4));
        write_SPI(0x00);

        PORTB |= DF_CHIP_SELECT;            // disable DataFlash

        block_counter++;
		if ((block_counter&7)==0) {uart_transmit('.');}
        while(!(PINB & 0x02));              // wait until block is erased
    }
	uart_transmit(0x0D);					//CRLF
	uart_transmit(0x0A);
    SPCR = 0x00;                            //disable SPI        
}

static unsigned int buffer_counter, page_counter;


void write_to_flash(unsigned char flash_data)
{
	
    
/*    if((ACSR&CLEARED))                       // if flag is set that new data has to be written
    {
        buffer_counter = 0;
        page_counter = 1;                   // reset the counter if new data has to be written
        ACSR &= (~CLEARED);                       // clear the signal flag
    }
*/
    

    PORTB &= ~DF_CHIP_SELECT;               // enable DataFlash
    if (usebuf2) {
		write_SPI(BUFFER_2_WRITE);
	} else {
	    write_SPI(BUFFER_1_WRITE);
	}
    write_SPI(0x00);                         // don't cares
    write_SPI((char)(buffer_counter>>8));    // don't cares plus first two bits of buffer address
    write_SPI((char)buffer_counter);         // buffer address (max. 2^8 = 256 pages)
    write_SPI(flash_data);                   // write data into SPI Data Register
        
    PORTB |= DF_CHIP_SELECT;                // disable DataFlash 
    
    buffer_counter++; 
        
    if (buffer_counter > 263)               // if buffer full write buffer into memory page
    {
        buffer_counter = 0;
        if (page_counter < 4096)            // if memory is not full   
        { 		   
		    while(!(PINB & 0x02));                  // check if flash is busy
            PORTB &= ~DF_CHIP_SELECT;       // enable DataFlash
			if (usebuf2) {
				write_SPI(B2_TO_MM_PAGE_PROG_WITHOUT_ERASE);// write data from buffer1 to page 
				usebuf2=0;
			} else {
				write_SPI(B1_TO_MM_PAGE_PROG_WITHOUT_ERASE);// write data from buffer1 to page 
				usebuf2=1;
			}			
            write_SPI((char)(page_counter>>7));
            write_SPI((char)(page_counter<<1));
            write_SPI(0x00);                    // don't cares
        
            PORTB |= DF_CHIP_SELECT;        // disable DataFlash
            page_counter++;
        }
        else
        {
            //PORTB |= 0x08;                  // turn LED off
            //while (!(PIND & 2));            // wait until button for recording (button 1) is released
        }
    }
}


void recording(unsigned short from, unsigned short length)
{   

	signed short t;
    // interrupt disabled, SPI port enabled, master mode, MSB first, SPI mode 3, Fcl/4
    SPCR = 0x5C;           
   
    a2dStartConvert();
	TCNT1=0;
	ADPCMInit();	
	unsigned char adpcmtemp;
	buffer_counter=0;
	page_counter=from;
	length+=from;
    do
    {
		PORTA|=128;
        if (format==WAVE||format==WAVE16) {
			a2dStartConvert();
			do
			{
			} while(!(ADCSR&(1<<ADIF)));         // Wait for A/D conversion to finish
			//proved vlastni zapis
			write_to_flash((unsigned char)((unsigned short)a2dConvert10bit()>>2));
      		PORTA&=~128;
			if (format==WAVE) {
			 do {
			 } while (TCNT1<2000);
			} else {
			 do {
			 } while (TCNT1<1000);
			}			
		} else {				
			//LSB NAPRED
			a2dStartConvert();
			do
			{
			} while(!(ADCSR&(1<<ADIF)));         // Wait for A/D conversion to finish
			//cekame
			if (format==ADPCM) {
				do {
				} while (TCNT1<1000);
			} else {
				do {
				} while (TCNT1<2000);
			}
			//ted MSB
			a2dStartConvert();
			//koduj ADPCM v dobe, kdy by ses jinak flakal
			t=(signed short)(((signed short)a2dConvert10bit()-512)*127); //2x zesilit
			adpcmtemp=ADPCMEncoder(t)&0x0F;
			do
			{
			} while(!(ADCSR&(1<<ADIF)));         // Wait for A/D conversion to finish
			//koduj ADPCM
			t=(signed short)(((signed short)a2dConvert10bit()-512)*127); //2x zesilit
			
			adpcmtemp|=ADPCMEncoder(t)<<4;
			
			//proved vlastni zapis
			write_to_flash(adpcmtemp);
				
			PORTA&=~128;				
			if (format==ADPCM) {
				do {
				} while (TCNT1<2000);
			} else {
				do {
				} while (TCNT1<4000);
			}
  		}
        TCNT1=0;
		//fprintf_P(seriak,PSTR("%d\n"),((unsigned char)(a2dConvert10bit()>>2)));
    } while (!interruptflag&&(page_counter<length));                  // loop while button for recording (button 1) is pressed
    
    SPCR = 0x00;                            // disable SPI        
}

void next_page_to_next_buffer (unsigned char active_buffer, unsigned int page_counter)
{
//    unsigned char temp = 0x80;

    while(!(PINB & 0x02));                  // wait until flash is not busy
    
    PORTB &= ~DF_CHIP_SELECT;               // enable DataFlash
                
    if (active_buffer == 1)                 // if buffer1 is the active buffer
    {
          write_SPI(MM_PAGE_TO_B2_XFER);      // transfer next page to buffer2
    }
    else                                    // else
    {
           write_SPI(MM_PAGE_TO_B1_XFER);          // transfer next page to buffer1
    }
    write_SPI((char)(page_counter >> 7));
    write_SPI((char)(page_counter << 1));
    write_SPI(0x00);

    PORTB |= DF_CHIP_SELECT;                // disable DataFlash and start transaction     
}
 
 
void outdata(unsigned short dataleft, unsigned short dataright)
{
	unsigned char count;
	//ovlada vodice LRCLK, BCLK, DOUT
	// LRCLK ... PA2
	#define LRCLK	4
	// BCLK  ... PA3
	#define BCLK	8
	// DOUT  ... PA4
	#define DOUT	16
	
	//levy kanal
	PORTA&=(unsigned char)~LRCLK;
	 PORTA|=BCLK;
	 PORTA&=(unsigned char)~BCLK;
	//vystavime MSB...LSB+1
	count=16;
	while (count--) {
	 //impuls 
	 PORTA|=BCLK;
	 PORTA&=(unsigned char)~BCLK;
	 //vystav data
	 if (dataleft&0x8000) {
	  PORTA|=DOUT;
	 } else {
	  PORTA&=(unsigned char)~DOUT;
	 }
	 //posun registr
	 dataleft=dataleft<<1;
	}
	//vystav LSB
    if (dataleft&0x8000) {
	 PORTA|=DOUT;
	} else {
	 PORTA&=(unsigned char)~DOUT;
	}
	
	//a ted to stejne pro pravy kanal
	PORTA|=LRCLK;
	 PORTA|=BCLK;
	 PORTA&=(unsigned char)~BCLK;
	//vystavime MSB...LSB+1
	count=16;
	while (count--) {
	 //impuls 
	 PORTA|=BCLK;
	 PORTA&=(unsigned char)~BCLK;
	 //vystav data
	 if (dataright&0x8000) {
	  PORTA|=DOUT;
	 } else {
	  PORTA&=(unsigned char)~DOUT;
	 }
	 //posun registr
	 dataright=dataright<<1;
	}
	//vystav LSB
    if (dataright&0x8000) {
	 PORTA|=DOUT;
	} else {
	 PORTA&=(unsigned char)~DOUT;
	}
}

unsigned char laho=127;

void active_buffer_to_speaker (unsigned char active_buffer)
{
    // until active buffer not empty read active buffer to speaker
    
    unsigned int buffer_counter = 264;
	
    unsigned char temp = 0x80; 
        
    PORTB &= ~DF_CHIP_SELECT;               // enable DataFlash     

    if (active_buffer == 1)                 // if buffer1 is the active buffer
    {
//		uart_transmit('-');
        write_SPI(BUFFER_1_READ);           // read from buffer1
    }
    else                                    // else
    {
		//uart_transmit('=');
        write_SPI(BUFFER_2_READ);               // read from buffer2
    }
    write_SPI(0x00);                          // write don't care byte
    write_SPI(0x00);                          // write don't care byte
    write_SPI(0x00);                          // start at buffer address 0
    write_SPI(0x00);                          // write don't care byte
    signed long decoderout;     
	unsigned char meziho;
    do
    {
	
        write_SPI(0xFF);                     // write dummy value to start register shift
		if (format==ADPCM||format==ADPCM8) {
		    temp=SPDR;			
			//if (previndex<45)
       		//	{previndex=50;}
			if (format==ADPCM) {
				do {
				} while (TCNT1<1000);
			} else {
				do {
				} while (TCNT1<2000);
			}			
			decoderout=(((signed long)ADPCMDecoder(temp&0x0F)+32768));
			OCR0 = (unsigned char)(decoderout/256);
			outdata((unsigned short)((unsigned long)decoderout*vole/256),(unsigned short)((unsigned long)decoderout*vori/256));	
			PORTA&=(unsigned char)~128; 
			if (format==ADPCM) {
				do {
				} while (TCNT1<2000);
			} else {
				do {
				} while (TCNT1<4000);
			}
			TCNT1 = 0;
			PORTA|=128; 
			decoderout=(((signed long)ADPCMDecoder(temp>>4)+32768));
			OCR0 = (unsigned char)(decoderout/256);
			outdata((unsigned short)((unsigned long)decoderout*vole/256),(unsigned short)((unsigned long)decoderout*vori/256));	
		} else {
			temp=SPDR;
			PORTA&=(unsigned char)~128; 
				if (format==WAVE) {
				meziho=(temp+laho)>>1;
				laho=temp;
				outdata((unsigned short)meziho*vole,(unsigned short)meziho*vori);	
				do {
				} while (TCNT1<1000);
				OCR0 = temp;
				outdata((unsigned short)temp*vole,(unsigned short)temp*vori);	
				do {
				} while (TCNT1<2000);
			} else {
				OCR0 = temp;
				outdata((unsigned short)temp*vole,(unsigned short)temp*vori);	
				do {
				} while (TCNT1<1000);
			}
			PORTA|=128; 
			TCNT1 = 0;
		}		
     } while (--buffer_counter);                          
	 //fprintf_P(seriak,PSTR("%u - %u\n"),dmin,dmax);
     PORTB |= DF_CHIP_SELECT;               // disable DataFlash
}


//unsigned int page_counter;

void playback(unsigned short from,unsigned short length)
{      
    ADPCMInit();
	page_counter = from;
//    unsigned int buffer_counter = 0;
    unsigned char active_buffer = 1;        // active buffer = buffer1
//    unsigned char temp = 0x80;
	OCR0=127;
	TCNT0 = 0;
    TCCR0 = 0x71;
    //ADPCMInit();
    // interrupt disabled, SPI port enabled, master mode, MSB first,  SPI mode 3, Fcl/4
    SPCR = 0x5C;
	OCR0=127;
		
    next_page_to_next_buffer (active_buffer, page_counter);  // read page0 to buffer1 
        
    while (!(PINB & 0x02));                 // wait until page0 to buffer1 transaction is finished
    TCNT1 = 0;
	length+=from;
	if (length>4094) {length=4095;};
    
	while ((page_counter < length)&&!interruptflag) // while button for playback (button 2) is pressed
    {   
        page_counter++;                     // now take next page
		
		
		
        next_page_to_next_buffer (active_buffer, page_counter);         
        active_buffer_to_speaker (active_buffer);        
        
        if (active_buffer == 1)             // if buffer1 is the active buffer
        {
          active_buffer++;                    // set buffer2 as active buffer
        }
        else                                // else
        {
          active_buffer--;                    // set buffer1 as active buffer
        }      
    }
    //TIMSK = 0x00;                           // disable all interrupts
    //TCCR1B = 0x00;                          // stop counter1
    OCR0 = 127;	
    SPCR = 0x00;                            // disable SPI
}
